local AYB = AllYourBase

AYB.Constants = {}
AYB.Constants.CurrentVersion = "1.0.4"
AYB.Constants.debugLast = "Nothing"
AYB.Constants.isCrafterOpen = false
AYB.Constants.lastCrafterOpen = 0
AYB.Constants.shouldSyncShipments = false
AYB.Constants.CurrentModelAnimation = 60
AYB.Constants.PrintAtPEWTable = {}
AYB.Constants.BlockNotificationsTable = {}
AYB.Indices = {}
AYB.ReportLists = { {}, {}, {}, {}, {} }
AYB.Constants.SaveForLaterTable = {}
AYB.Constants.MaxSavedNotifications = 3
AYB.Constants.CurrentSavedNotifications = 0
local source = AYB.Constants.debugLast

--[[
AllYourBaseVars = {
	["Settings"] = {},
	["Data"] = {},
	["CurrentVersion"] = -1
	}
--]]
	
local me, shortMe, race, faction

AYB.CompletedQueue = {}

AYB.Main = CreateFrame("Frame","AllYourBaseMain")
AYB.Main.Timer = 0

AYB.ShipmentUpdater = CreateFrame("Frame", "AllYourBaseShipmentUpdater")
AYB.WhichCrafter = CreateFrame("Frame", "AllYourBaseDetermineCrafter")
AYB.SliderWindow = CreateFrame("Frame", "AllYourBaseResourceLimitSliderWindow", AllYourBaseReportPageReport, "TranslucentFrameTemplate")
AYB.Slider = CreateFrame("Slider", "AllYourBaseResourceSlider", AllYourBaseResourceLimitSliderWindow, "OptionsSliderTemplate")
AYB.DailyResetFrame = CreateFrame("Frame")

for k, v in pairs({
	"CHAT_MSG_SYSTEM",
	"UNIT_SPELLCAST_SUCCEEDED",
	"LOOT_CLOSED",
	"QUEST_LOG_UPDATE",
	"PLAYER_REGEN_ENABLED",
	"PLAYER_REGEN_DISABLED",
	"QUEST_FINISHED",
	"PLAYER_ENTERING_WORLD",
	"SHOW_LOOT_TOAST",
	"ADDON_LOADED",
	"PLAYER_LOGIN",
	"UNIT_INVENTORY_CHANGED",
	"SHIPMENT_CRAFTER_CLOSED",
	"SHIPMENT_CRAFTER_OPENED",
	"SHIPMENT_CRAFTER_REAGENT_UPDATE",
	"SHIPMENT_UPDATE",
	"GARRISON_ARCHITECT_CLOSED",
	"GARRISON_ARCHITECT_OPENED",
	"GARRISON_BUILDINGS_SWAPPED",
	"GARRISON_BUILDING_ACTIVATABLE",
	"GARRISON_BUILDING_ACTIVATED",
	"GARRISON_BUILDING_ERROR",
	"GARRISON_BUILDING_LIST_UPDATE",
	"GARRISON_BUILDING_PLACED",
	"GARRISON_BUILDING_REMOVED",
	"GARRISON_BUILDING_UPDATE",
	"GARRISON_FOLLOWER_ADDED",
	"GARRISON_FOLLOWER_LIST_UPDATE",
	"GARRISON_FOLLOWER_REMOVED",
	"GARRISON_FOLLOWER_XP_CHANGED",
	"GARRISON_HIDE_LANDING_PAGE",
	"GARRISON_INVASION_AVAILABLE",
	"GARRISON_INVASION_UNAVAILABLE",
	"GARRISON_LANDINGPAGE_SHIPMENTS",
	"GARRISON_MISSION_BONUS_ROLL_COMPLETE",
	"GARRISON_MISSION_BONUS_ROLL_LOOT",
	"GARRISON_MISSION_COMPLETE_RESPONSE",
	"GARRISON_MISSION_FINISHED",
	"GARRISON_MISSION_LIST_UPDATE",
	"GARRISON_MISSION_NPC_CLOSED",
	"GARRISON_MISSION_NPC_OPENED",
	"GARRISON_MISSION_STARTED",
	"GARRISON_MONUMENT_CLOSE_UI",	
	"GARRISON_MONUMENT_LIST_LOADED",
	"GARRISON_MONUMENT_REPLACED",
	"GARRISON_MONUMENT_SELECTED_TROPHY_ID_LOADED",
	"GARRISON_MONUMENT_SHOW_UI",
	"GARRISON_RECALL_PORTAL_LAST_USED_TIME",
	"GARRISON_RECALL_PORTAL_USED",
	"GARRISON_RECRUITMENT_FOLLOWERS_GENERATED",
	"GARRISON_RECRUITMENT_NPC_CLOSED",
	"GARRISON_RECRUITMENT_NPC_OPENED",
	"GARRISON_RECRUITMENT_READY",
	"GARRISON_RECRUIT_FOLLOWER_RESULT",
	"GARRISON_SHOW_LANDING_PAGE",
	"GARRISON_TRADESKILL_NPC_CLOSED",
	"GARRISON_UPDATE",
	"GARRISON_UPGRADEABLE_RESULT",
	"GARRISON_USE_PARTY_GARRISON_CHANGED",
	"SHIPMENT_UPDATE"}) do AYB.Main:RegisterEvent(v) end

AYB.WhichCrafter:RegisterEvent("SHIPMENT_CRAFTER_INFO")

function AYB.DailyResetFrame.OnUpdate(self, elapsed)
	self.timer = (self.timer or 0) + elapsed
	if self.timer > 1 then
		AYB.UpdateHasGarrisonStatus()
		self.timer = 0
		if AllYourBaseVars.Data[me].hasGarrison and C_Garrison.GetBuildings()[1] then
			AYB.CompareLoginTimes(me, "first frame")
			self:Hide()
		elseif AllYourBaseVars.Data[me].hasGarrison then
			AYB.Debug("No Building Info yet")
		end
	end
end

function AYB.Main.OnEvent(self, event, ...)
	if event == "CHAT_MSG_SYSTEM" and ... == DAILY_QUESTS_RESET then
		AYB.ResetDailyInformation(me, "DAILY_QUESTS_RESET")
	elseif event == "ADDON_LOADED" then
		if ... == "AllYourBase" then
			me = UnitName("player").."-"..GetRealmName()
			shortMe = UnitName("player")
			race = select(2, UnitRace("player"))
			faction = UnitFactionGroup("player")
		end
	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		local unit, spell = ...
		if spell == "Mining" and unit == "player" then
			local zone = GetSubZoneText()
			if zone == "Frostwall Mine" or zone == "Lunarfall Excavation" then
				AYB.Main.lootType = "ore"
			end
		elseif (spell == "Herbalism" or spell == "Herb Gathering") and unit == "player" then
			local zone = GetSubZoneText()
			if zone:find(UnitName("player")) then
				AYB.Main.lootType = "herb"
			end
		end
	elseif event == "LOOT_CLOSED" and self.lootType then
		local loot = self.lootType
		self.lootType = nil		
		AYB.DecrementNode(loot, me)
	elseif event == "QUEST_LOG_UPDATE" and AllYourBaseVars.Data[me].resetTime and IsLoggedIn() then
		if GetQuestResetTime() > AllYourBaseVars.Data[me].resetTime then
			AYB.ResetDailyInformation(me, "QUEST_LOG_UPDATE")
			AllYourBaseVars.Data[me].resetTime = GetQuestResetTime()
			AllYourBaseVars.Data[me].Time = time()
		end
	elseif event == "PLAYER_REGEN_DISABLED" and AllYourBaseVars.Settings.doNotNotifyDuringBattle then
		AYB.Constants.BlockNotificationsTable.combat = true
	elseif event == "PLAYER_REGEN_ENABLED" and AllYourBaseVars.Settings.doNotNotifyDuringBattle then
		AYB.Constants.BlockNotificationsTable.combat = nil
		if next(AYB.Constants.SaveForLaterTable) then
			AYB.DoSavedNotifications()
		else
		
		end
	elseif event == "QUEST_FINISHED" then
		AYB.UpdateHasGarrisonStatus()
	elseif event == "SHOW_LOOT_TOAST" then
		local arg1, arg2, arg3, arg4, arg5, arg6, arg7 = ...
		if arg1 == "currency" and arg2:find("Garrison Resources") and arg7 == 10 then -- arg7 appears to be the source for cache right now
			AYB.Debug("Resetting your Resources Counter!")
			AllYourBaseVars.Data[me].lastRetrievedCache = time()
			AllYourBaseVars.Data[me].doBroadcastCache = true
			AYB.CalculateResourceLimitTimers(me)
		end
	elseif event == "GARRISON_SHOW_LANDING_PAGE" then
		if not GarrisonLandingPage then
			return
		end
		if not AYB.Constants.FramesCreated then
			hooksecurefunc(GarrisonLandingPage.Report, "Show", function() AYB.StatusButton:Show() end)
			hooksecurefunc(GarrisonLandingPage.Report, "Hide", function() AYB.StatusButton:Hide() end)
			AYB.ShipmentUpdater:Hide()
			AYB.Constants.FramesCreated = true
			AYB.CreateButtonAndFrames()
		end
		if not next(AllYourBase.CharHasOpenItem(me)) then
			AYB.StatusButton.Texture:SetTexture(0, 1, 0, 0.4)
		else
			AYB.StatusButton.Texture:SetTexture(1, 0, 0, 0.4)
		end
	elseif event == "GARRISON_MISSION_STARTED" then
		AYB.StartMission(...)
	elseif event == "GARRISON_BUILDING_PLACED" then
		AYB.StartBuilding(false, ...)
	elseif event == "GARRISON_BUILDING_REMOVED" then
		AYB.StartBuilding(true, ...)
	elseif event == "GARRISON_MISSION_COMPLETE_RESPONSE" then
		AYB.RemoveCompletedMission(...)
	elseif event == "GARRISON_BUILDING_ACTIVATED" then
		AYB.RemoveCompletedBuilding(...)
	elseif event == "PLAYER_LOGIN" then
		if (not AllYourBaseVars) or AllYourBaseVars.CurrentVersion ~= AYB.Constants.CurrentVersion then
			AYB.InitializeAccountVariablesAndSettings()
			tinsert(AYB.Constants.PrintAtPEWTable, "PLAYER_LOGIN wanted to do initialize account!")
		end
		if not AllYourBaseVars.Data[me] then
			AYB.InitializeCharacterVariablesAndSettings(me)
			tinsert(AYB.Constants.PrintAtPEWTable, "PLAYER_LOGIN wanted to do initialize toon!")
		end
		AllYourBase.ReportPage_OnLoad(AllYourBaseReportPage)
		AYB.OptionsDropdown_OnLoad(AllYourBaseOptionsDropdown)
		AYB.BlacklistBuildingDropdown_OnLoad(AllYourBaseBlacklistBuildingDropdown) -- need to initialize this dropdown after PLAYER_LOGIN because it depends on saved variables
		AYB.ShipmentUpdater:Hide()
	elseif event == "GARRISON_MISSION_NPC_OPENED" or event == "GARRISON_ARCHITECT_OPENED" then -- when in the mission UI, suspend syncing, otherwise the information can get re-added between completing a mission and opening the loot chest
		AYB.Main:Hide()
	elseif event == "GARRISON_MISSION_NPC_CLOSED" or event == "GARRISON_ARCHITECT_CLOSED" then -- resume sync when the UI is closed
		AYB.Main:Show()
	elseif event == "SHIPMENT_UPDATE" and ... then
		if AYB.Constants.isCrafterOpen then
			AYB.Constants.shouldSyncShipments = true
		end
	elseif event == "SHIPMENT_CRAFTER_OPENED" then
		AYB.WhichCrafter:Show()
		AYB.Constants.isCrafterOpen = true
	elseif event == "SHIPMENT_CRAFTER_CLOSED" then
		AYB.WhichCrafter:Hide()		
		AYB.Constants.isCrafterOpen = false
		if AYB.Constants.shouldSyncShipments then
			AYB.Constants.shouldSyncShipments = false
			C_Garrison.RequestLandingPageShipmentInfo()
			GarrisonLandingPageReport_GetShipments(GarrisonLandingPageReport)
			AYB.ShipmentUpdater.Timer = 0
			AYB.ShipmentUpdater:Show()
		end
	end
end

function AYB.CreateButtonAndFrames()
	if not GarrisonLandingPage then
		return
	end
	AYB.StatusButton = CreateFrame("Button", "AllYourBaseStatusButton", GarrisonLandingPage, "AllYourBaseReportButtonTemplate")
	local statusButton = AYB.StatusButton
	statusButton:SetPoint("BOTTOMLEFT", 46, 40)
	_G["AllYourBaseStatusButtonTexture"]:SetTexture("Interface\\Icons\\ACHIEVEMENT_GUILDPERK_GMAIL")
	AYB.StatusButton.Texture = statusButton:CreateTexture(nil, "OVERLAY")
	AYB.StatusButton.Texture:SetHeight(30)
	AYB.StatusButton.Texture:SetWidth(30)
	AYB.StatusButton.Texture:SetAllPoints(statusButton)
	statusButton:Show()
	statusButton:SetScript("OnClick", function(self) HideParentPanel(self) AYB.DisplayAllReports("slash") end)
	statusButton:SetScript("OnEnter", function(self) AYB.StatusButton_OnEnter(self) end)
	statusButton:SetScript("OnLeave", function(self) AYB.StatusButton_OnLeave(self) end)
	local text = statusButton:CreateFontString(nil, "Border", "ChatFontSmall")
	text:SetText("All Your Base\nStatus Report")
	text:SetPoint("TOPLEFT", 35, -2)
	text:Show()
	AYB.SliderWindow:SetParent(AllYourBaseReportPageReport)
	AYB.SliderWindow:SetHeight(120)
	AYB.SliderWindow:SetWidth(350)
	AYB.SliderWindow:SetPoint("CENTER")
	AYB.SliderWindow:Hide()		
	AllYourBaseResourceSlider:SetValue(AllYourBaseVars.Settings.resourceWatchLimit)
	AllYourBaseResourceSliderText:SetFormattedText("Current Garrison Cache Notification Limit: %d", AllYourBaseVars.Settings.resourceWatchLimit)
	AYB.Slider:SetHeight(15)
	AYB.Slider:SetWidth(200)
	AYB.Slider:SetPoint("CENTER")
	AYB.Slider:SetMinMaxValues(0, 500)
	AYB.Slider:SetValueStep(5)
	_G[AYB.Slider:GetName().."Low"]:SetText("0")
	_G[AYB.Slider:GetName().."High"]:SetText("500")	
	AYB.Slider:SetScript("OnValueChanged", function(self, value)
		-- start fix
		if not self._onsetting then   -- is single threaded 
			self._onsetting = true
			self:SetValue(self:GetValue())
			value = self:GetValue()     -- cant use original 'value' parameter
			self._onsetting = false
		else return end               -- ignore recursion for actual event handler
			-- end fix
		_G[self:GetName().."Text"]:SetFormattedText("Current Garrison Cache Notification Limit: %d", value)
	end)
	AYB.Slider:Show()
	AllYourBaseResourceSliderText:ClearAllPoints()
	AllYourBaseResourceSliderText:SetPoint("CENTER", 0, 25)
	AYB.Slider:SetValue(AllYourBaseVars.Settings.resourceWatchLimit)
	local cb = CreateFrame("Button", "AllYourBaseResourceLimitAccept", AYB.SliderWindow, "UIPanelButtonTemplate")
	cb:SetPoint("BOTTOM", 0, 20)
	cb:SetText("OK")
	cb:SetHeight(25)
	cb:SetWidth(40)
	cb:SetScript("OnClick", function(self)
		AllYourBaseVars.Settings.resourceWatchLimit = AYB.Slider:GetValue()
		AYB.CalculateResourceLimitTimers()
		self:GetParent():Hide()
		AYB.RefreshStatusReport()
	end)
end

function AYB.ParseCrafter(self, event, success, queued, total, plotID)
	local buildingID
	for k, v in ipairs(C_Garrison.GetBuildings()) do
		if v.plotID == plotID then
			buildingID = v.buildingID
			break
		end
	end
	AYB.Constants.lastCrafterOpen = buildingID
end

function AYB.Main.OnUpdate(self, timer)
	AYB.Main.Timer = AYB.Main.Timer + timer
	if AYB.Main.Timer >= 3 then
		AYB.Main.Timer = 0
		AYB.Sync()
	end
end

function AYB.ShipmentUpdater.OnUpdate(self, elapsed)
	if not self.Timer then
		self.Timer = 0
	end
	self.Timer = self.Timer + elapsed
	if self.Timer >= 2 then
		AYB.StartShipment(AYB.Constants.lastCrafterOpen)
		self.Timer = 0
		self:Hide()
	end
end

function AYB.StartMission(...)
	local started = ...
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.missionID == started then
			AllYourBaseVars.Data[me].Missions[started] = v
			AllYourBaseVars.Data[me].Missions[started].startTime = time()
			AllYourBaseVars.Data[me].Missions[started].endTime = time() + AYB.TextToSecs(v.timeLeft)
			AllYourBaseVars.Data[me].Missions[started].doBroadcast = true
		end
	end
end

function AYB.StartBuilding(hasRemoved, ...)
	local arg1, arg2 = ...
	local oldBuilding
	if hasRemoved then
		oldBuilding = AYB.BuildingIDsToNames[arg2][faction]
	end
	if oldBuilding and AllYourBaseVars.Data[me].Buildings[oldBuilding] then
		AllYourBaseVars.Data[me].Buildings[oldBuilding] = nil
	end		
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.isBuilding then
			if not AllYourBaseVars.Data[me].Buildings[v.name] then
				AllYourBaseVars.Data[me].Buildings[v.name] = {}
				AllYourBaseVars.Data[me].Buildings[v.name].name = v.name
				AllYourBaseVars.Data[me].Buildings[v.name].startTime = time()
				AllYourBaseVars.Data[me].Buildings[v.name].doBroadcast = true
				AllYourBaseVars.Data[me].Buildings[v.name].endTime = time() + AYB.TextToSecs(v.timeLeft)
			end
		end
	end
end

function AYB.StartShipment(crafter)
	local s = {C_Garrison.GetLandingPageShipmentInfo(crafter)}
	local building = AYB.BuildingIDsToNames[crafter][faction]
	if s[4] and s[5] and s[8] then
		AllYourBaseVars.Data[me].Shipments[building] = {
			["endTime"] = time() + (s[5] - s[4] - 1) * 3600 * 4 + AYB.TextToSecs(s[8]) + 57, -- 57 is a fudge factor since the string for time left immediately starts at 3 hr 59 minutes
			["doBroadcast"] = true,
			["blacklist"] = false,
			} 
		if AllYourBaseVars.Settings.notifyOnQueueUpdate then
			AYB.Print(format("Work order queue for %s has been updated!", building))
		end
	else
		AYB.Print("I think this is the first expedited shipment for ".. building)
	end
end

function AYB.Sync()
	AYB.AddAnyMissing()
	if not AYB.Constants.hasShownLoginReport and AllYourBaseVars.Settings.displayReportAtLogin and not InCombatLockdown() then
		--[[
		if not GarrisonLandingPage then
			LoadAddOn("Blizzard_GarrisonUI")
		end
		--]]
		AYB.DisplayAllReports("initial")
		AYB.Constants.hasShownLoginReport = true
		AYB.PrintAtPEW(AYB.Constants.PrintAtPEWTable)
		return
	elseif not AYB.Constants.hasShownLoginReport then
		AYB.PrintAtPEW(AYB.Constants.PrintAtPEWTable)
		AYB.Constants.hasShownLoginReport = true
	end
	wipe(AYB.CompletedQueue)
	if AllYourBaseVars.Settings.scanForMissions then
		local onDemand, completed, isOnlySelf = AYB.SearchAllForCompleteMissions(false, "from Sync")
		if completed then
			if #completed > 1 then
				AYB.Debug("Tried to have multiple characters pass through the Sync command.")
			end
			if next(AYB.Constants.BlockNotificationsTable) then -- don't call the notifications, add them to SaveForLaterTable
				local command, toon, missionID = ""
				if AllYourBaseVars.Settings.displayTextNotifications then
					command = command.."text"
				end
				if AllYourBaseVars.Settings.displayToastNotifications then
					command = command.."toast"
				end
				if AllYourBaseVars.Settings.displaySoundNotifications then
					command = command.."sound"
				end
				if #completed == 1 then
					toon, mission = completed[1][1], completed[1][2]
				end
				if toon then
					tinsert(AYB.Constants.SaveForLaterTable, {command, "mission", toon})
				end
			else
				if #completed == 1 then
					local toon = completed[1][1]
					if AllYourBaseVars.Settings.displayTextNotifications and not isOnlySelf then
						AYB.FakeWhisper(toon, "Mission completed!")
					end
					if AllYourBaseVars.Settings.displayToastNotifications and not isOnlySelf then
						AYB.DisplayCompletedSingleMission(toon)
					end
					if AllYourBaseVars.Settings.displaySoundNotifications and not isOnlySelf then
						AYB.SoundNotification("Mission", faction)
					end
				end
			end
		end
	end
	wipe(AYB.CompletedQueue)
	if AllYourBaseVars.Settings.scanForBuildings then
		local onDemand, completed, isOnlySelf = AYB.SearchAllForCompleteBuildings(false, "from Sync")
		if completed then
			if #completed > 1 then
				AYB.Debug("Tried to have multiple character buildings pass through the Sync command.")
			end
			if next(AYB.Constants.BlockNotificationsTable) then -- don't call the notifications, add them to SaveForLaterTable
				local command, toon = ""
				if AllYourBaseVars.Settings.displayTextNotifications then
					command = command.."text"
				end
				if AllYourBaseVars.Settings.displayToastNotifications then
					command = command.."toast"
				end
				if AllYourBaseVars.Settings.displaySoundNotifications then
					command = command.."sound"
				end
				if #completed == 1 then
					toon, mission = completed[1][1], completed[1][2]
				end
				if toon then
					tinsert(AYB.Constants.SaveForLaterTable, {command, "building", toon})
				end
			else
				if #completed == 1 then
					local toon, building = completed[1][1], completed[1][2]
					if AllYourBaseVars.Settings.displayTextNotifications then
						AYB.FakeWhisper(toon, format("My %s is completed!", building))
					end
					if AllYourBaseVars.Settings.displayToastNotifications then
						AYB.DisplayCompletedSingleBuilding(toon)
					end
					if AllYourBaseVars.Settings.displaySoundNotifications then
						AYB.SoundNotification("Building", faction)
					end
				end
			end
		end
	end
	wipe(AYB.CompletedQueue)
	if AllYourBaseVars.Settings.scanForShipments then
		local onDemand, completed, isOnlySelf = AYB.SearchAllForCompleteShipments(false, "from Sync")
		if completed then
			if #completed > 1 then
				AYB.Debug("Tried to have multiple character shipments pass through the Sync command.")
			end
			if next(AYB.Constants.BlockNotificationsTable) then -- don't call the notifications, add them to SaveForLaterTable
				local command, toon = ""
				if AllYourBaseVars.Settings.displayTextNotifications then
					command = command.."text"
				end
				if AllYourBaseVars.Settings.displayToastNotifications then
					command = command.."toast"
				end
				if AllYourBaseVars.Settings.displaySoundNotifications then
					command = command.."sound"
				end
				if #completed == 1 then
					toon, mission = completed[1][1], completed[1][2]
				end
				if toon then
					tinsert(AYB.Constants.SaveForLaterTable, {command, "shipment", toon})
				end
			else
				if AllYourBaseVars.Settings.displayTextNotifications then
					if isOnlySelf then
						AYB.Print(format("My %s is no longer producing goods, Commander!", completed[1][2]))
					elseif #completed == 1 then
						local toon, shipment = completed[1][1], completed[1][2]
						AYB.FakeWhisper(toon, format("My %s is no longer producing goods!", shipment))
					end
				end
				if AllYourBaseVars.Settings.displayToastNotifications and #completed == 1 then
					local toon, shipment = completed[1][1], completed[1][2]
					AYB.DisplayCompletedSingleShipment(toon, shipment)
				end
				if AllYourBaseVars.Settings.displaySoundNotifications and #completed == 1 then
					AYB.SoundNotification("Shipment", faction)
				end
			end
		end
	end
	wipe(AYB.CompletedQueue)
	if AllYourBaseVars.Settings.scanForResources then
		local onDemand, completed, isOnlySelf = AYB.SearchAllForResourceLimit(false, "from Sync")
		if next(AYB.Constants.BlockNotificationsTable) then -- don't call the notifications, add them to SaveForLaterTable
			local command, toon = ""
			if AllYourBaseVars.Settings.displayTextNotifications then
				command = command.."text"
			end
			if AllYourBaseVars.Settings.displayToastNotifications then
				command = command.."toast"
			end
			if AllYourBaseVars.Settings.displaySoundNotifications then
				command = command.."sound"
			end
			if #completed == 1 then
				toon = completed[1][1]
			end
			if toon then
				tinsert(AYB.Constants.SaveForLaterTable, {command, "resources", toon})
			end
		else
			if #completed == 1 then
				local toon, limit = completed[1][1], AllYourBaseVars.Settings.resourceWatchLimit
				if AllYourBaseVars.Settings.displayTextNotifications then
					AYB.FakeWhisper(toon, format("My Garrison Cache has exceeded %d resources!", limit))
				end
				if AllYourBaseVars.Settings.displayToastNotifications then
					AYB.DisplayResourceLimitReached(toon, limit)
				end
				if AllYourBaseVars.Settings.displaySoundNotifications then
					AYB.SoundNotification("Resources", faction)
				end
			end
		end
	end
end

function AYB.AddAnyMissing()
	for k, v in ipairs(C_Garrison.GetLandingPageItems()) do
		if v.isBuilding == false and AllYourBaseVars.Data[me].Missions then -- if this is not a Building, it's a Mission
			if not AllYourBaseVars.Data[me].Missions[v.missionID] then
				AllYourBaseVars.Data[me].Missions[v.missionID] = v
				AllYourBaseVars.Data[me].Missions[v.missionID]["startTime"] = "unknown"
				local timeLeft = C_Garrison.GetLandingPageItems()[k].timeLeft
				AllYourBaseVars.Data[me].Missions[v.missionID].endTime = time() + AYB.TextToSecs(timeLeft)
				AllYourBaseVars.Data[me].Missions[v.missionID].doBroadcast = true
			end
		elseif AllYourBaseVars.Data[me].Buildings then -- it's a Building
			if not AllYourBaseVars.Data[me].Buildings[v.name] then
				AllYourBaseVars.Data[me].Buildings[v.name] = {}
				AllYourBaseVars.Data[me].Buildings[v.name].name = v.name
				AllYourBaseVars.Data[me].Buildings[v.name]["startTime"] = "unknown"
				local timeLeft = C_Garrison.GetLandingPageItems()[k].timeLeft
				AllYourBaseVars.Data[me].Buildings[v.name].endTime = time() + AYB.TextToSecs(timeLeft)
				AllYourBaseVars.Data[me].Buildings[v.name].doBroadcast = true
			end
		end
	end
	
	local buildings, shipments = C_Garrison.GetBuildings(), {}
	for i = 1, #buildings do
		local buildingID = buildings[i].buildingID
		if buildingID and buildingID ~= 8 then -- level 1 war mill doesn't have the ability to create shipments
			-- local name, texture, shipmentCapacity, shipmentsReady, shipmentsTotal, creationTime, duration, timeleftString, itemName, itemIcon, itemQuality, itemID = C_Garrison.GetLandingPageShipmentInfo(buildingID);
			shipments[buildingID] = {C_Garrison.GetLandingPageShipmentInfo(buildingID)}
		end
	end
	for k, v in pairs(shipments) do
		if v[1] and AllYourBaseVars.Data[me].Shipments and not AllYourBaseVars.Data[me].Shipments[v[1]] then
			if v[8] then
				v[8] = AYB.TextToSecs(v[8]) + time() + (v[5] - v[4] - 1) * 3600 * 4 + 57
			else
				v[8] = time() - 1
			end
			AllYourBaseVars.Data[me].Shipments[v[1]] = {
				["blacklist"] = false,
				["doBroadcast"] = true,
				["endTime"] = v[8]
			}
		end
	end
end

function AYB.RemoveCompletedMission(missionID)
	if AllYourBaseVars.Data[me].Missions[missionID] then
		AllYourBaseVars.Data[me].Missions[missionID] = nil
	else
		AYB.Debug(format("COULD NOT REMOVE %s PLEASE RESEARCH", missionID))
	end
end

function AYB.RemoveCompletedBuilding(...)
	local _, buildingID = ...
	local name = AYB.BuildingIDsToNames[buildingID][UnitFactionGroup("player")]
	AllYourBaseVars.Data[me].Buildings[name] = nil
	--[[
	local mines, gardens = {29, 136, 137}, {61, 62, 63}
	if tContains(mines, buildingID) then
		AYB.IncrementNode("ore", me, 5)
	elseif tContains(gardens, buildingID) then
		AYB.IncrementNode("herb", me, buildingID == 63 and 5 or 4)
	end
	]]--
end

function AYB.NextToComplete(dataType)
	local leastTimeRemaining, whichToon, nextName = 7 * 24 * 3600
	for k, v in pairs(AllYourBaseVars.Data) do
		for l, w in pairs(v[dataType]) do
			local thisTimeLeft = w.endTime - time()
			if (thisTimeLeft <= leastTimeRemaining) and not (time() > w.endTime) then
				leastTimeRemaining = thisTimeLeft
				whichToon = k
				nextName = w.name or l
			end
		end
	end
	
	return whichToon, nextName, leastTimeRemaining
end

function AYB.CleanUpUnusedEntries(dataType)
	if AllYourBaseVars.Data[me][dataType] then
		for k, v in pairs(AllYourBaseVars.Data[me][dataType]) do
			local ID = ( dataType == "Missions" and v.missionID ) or ( dataType == "Buildings" and v.name ) or ( dataType == "Shipments" and k )
			local isActive, holdingTable
			holdingTable = ( dataType == "Shipments" and C_Garrison.GetBuildings() ) or C_Garrison.GetLandingPageItems()
			for l, w in ipairs(holdingTable) do
				if ( dataType == "Missions" and ID == w.missionID ) or ( dataType == "Buildings" and ID == w.name ) or ( dataType == "Shipments" and ID == AYB.BuildingIDsToNames[w.buildingID][faction] ) then
					isActive = true
					break
				end
			end
			if not isActive then
				AllYourBaseVars.Data[me][dataType][ID] = nil
			end
		end
	end
end

function AYB.SearchAllForCompleteMissions(onDemand, source) -- returns quantity of completed missions, and a string with a report (if multiple) - otherwise triggers a single notification to fire (not a report)
	local meComplete, otherComplete
	local PH, anyComplete = {}
	for k, v in pairs(AllYourBaseVars.Data) do
		if v.showMyMissions then
			for l, w in pairs(v.Missions) do
				if time() >= w.endTime and (w.doBroadcast or onDemand) then -- if time is expired, and either this was an on-demand request or the broadcast hasn't happened yet (first time)
					if source ~= "initial" then
						w.doBroadcast = false
					end
					tinsert(PH, w.missionID)	
					anyComplete = true
					--[[
					if not AYB.CompletedQueue[k] then
						AYB.CompletedQueue[k] = {}
					end
					tinsert(AYB.CompletedQueue[k], w.missionID)
					--]]
					if k == me then
						meComplete = true
					else
						otherComplete = true
					end
				end
			end
			if anyComplete then
				anyComplete = false
				tinsert(AYB.CompletedQueue, {k, unpack(PH)})
				if onDemand then
					tinsert(AYB.ReportLists[1], {k, unpack(PH)})
				end				
				wipe(PH)
			end
		end
	end
	if onDemand then -- onDemand can return multiple completed missions. Check to see if any are done, and generate a report if so. Otherwise, return 0.
		if meComplete or otherComplete then
			return true, AYB.ReportLists[1], (not otherComplete and meComplete), "is this thing on?"
		else
			return true, {}, nil
		end
	else -- sync checks only return one completed mission (highly unlikely someone will have two missions completed within 3 second intervals)
		if meComplete and not otherComplete then -- if it's just the current character, do nothing, default UI handles that
			return false, AYB.CompletedQueue, true
		elseif not meComplete and otherComplete then -- if it's just a different character, run the single mission notification
			return false, AYB.CompletedQueue, false
		end
	end
end

function AYB.DisplayCompletedSingleMission(character, fallthrough)
	if next(AYB.Constants.BlockNotificationsTable) and not fallthrough then
		tinsert(AYB.Constants.SaveForLaterTable, {"toast", "mission", character})
		return
	end
	local missionsInfo
	--[[	
	if AllYourBaseVars.Data[character].Missions[missionID] then
		missionInfo = AllYourBaseVars.Data[character].Missions[missionID]
	else -- why is this doing this?
		AYB.Print(format("Not sure why, but I just tried to get information about mission %s, which I don't have for %s!", missionID, character))
		return
	end
	--]]
	local toon = character:match("([^-]+)")
	GarrisonMissionAlertFrame.Name:SetText(toon);
	GarrisonMissionAlertFrame.MissionType:SetAtlas("GarrMission_MissionIcon-Combat");
	AlertFrame_AnimateIn(GarrisonMissionAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_MissionComplete");
end

function AYB.SearchAllForIdleMissions(onDemand, source)
	local idlers = {}
	for k, v in pairs(AllYourBaseVars.Data) do
		if v.showMyIdleMissions and v.hasGarrison then
			local idleCheck = true
			for l, w in pairs(v.Missions) do
				if w.endTime and time() < w.endTime then
					idleCheck = false
				end
			end
			if idleCheck then
				tinsert(idlers, {k})
				if onDemand then
					tinsert(AYB.ReportLists[2], {k})
				end
			end
		end
	end
	if idlers[1] then
		return idlers
	else
		return
	end
end

function AYB.SearchAllForCompleteBuildings(onDemand, source) -- returns quantity of completed buildings, and a string with a report (if multiple) - otherwise triggers a single notification to fire (not a report)
	local meComplete, otherComplete
	local PH, anyComplete = {}
	for k, v in pairs(AllYourBaseVars.Data) do
		if v.showMyBuildings then
			for l, w in pairs(v.Buildings) do
				if time() >= w.endTime and (w.doBroadcast or onDemand) then
					if source ~= "initial" then
						w.doBroadcast = false
					end
					tinsert(PH, w.name)	
					anyComplete = true
					--[[
					if not AYB.CompletedQueue[k] then
						AYB.CompletedQueue[k] = {}
					end
					tinsert(AYB.CompletedQueue[k], w.name)
					--]]
					if k == me then
						meComplete = true
					else
						otherComplete = true
					end
				end
			end
			if anyComplete then
				anyComplete = false
				tinsert(AYB.CompletedQueue, {k, unpack(PH)})
				if onDemand then
					tinsert(AYB.ReportLists[3], {k, unpack(PH)})
				end
				wipe(PH)
			end
		end
	end
	if meComplete or otherComplete then
		if onDemand and otherComplete then
			return true, AYB.ReportLists[3], false
		elseif otherComplete then -- sync, so it's a single building from someone else
			return false, AYB.CompletedQueue, false
		elseif onDemand and meComplete then
			-- AYB.Print(format("I have %d %s complete, Commander!", #AYB.CompletedQueue, #AYB.CompletedQueue > 1 and "buildings" or "building"))
			return true, AYB.ReportLists[3], true
		end
	elseif onDemand then
		-- AYB.Print("No one has any completed buildings, Commander!")
		return true, AYB.ReportLists[3], (meComplete and not otherComplete)
	end
end

function AYB.DisplayCompletedSingleBuilding(toon, fallthrough)
	if next(AYB.Constants.BlockNotificationsTable) and not fallthrough then
		tinsert(AYB.Constants.SaveForLaterTable, {"toast", "building", toon})
		return
	end
	local name = toon:match("([^-]+)-.+")
	GarrisonBuildingAlertFrame.Name:SetFormattedText("%s has a finished building!", name);
	AlertFrame_AnimateIn(GarrisonBuildingAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_BuildingComplete");
end

function AYB.SearchAllForCompleteShipments(onDemand, source) -- returns quantity of completed shipments, and a string with a report (if multiple) - otherwise triggers a single notification to fire (not a report)
	local meComplete, otherComplete
	local PH, anyComplete = {}
	for k, v in pairs(AllYourBaseVars.Data) do
		if v.showMyShipments then
			for l, w in pairs(v.Shipments) do
				if not w.blacklist then
					if time() >= w.endTime and (w.doBroadcast or onDemand) then
						if source ~= "initial" then
							w.doBroadcast = false
						end
						tinsert(PH, l)
						anyComplete = true
						--[[
						if not AYB.CompletedQueue[k] then
							AYB.CompletedQueue[k] = {}
						end
						tinsert(AYB.CompletedQueue[k], l)
						--]]
						if k == me then
							meComplete = true
						else
							otherComplete = true
						end
					end
				end
			end
			if anyComplete then
				anyComplete = false
				tinsert(AYB.CompletedQueue, {k, unpack(PH)})
				if onDemand then
					tinsert(AYB.ReportLists[4], {k, unpack(PH)})
				end
				wipe(PH)
			end
		end		
	end
	if meComplete or otherComplete then
		if onDemand then
			return true, AYB.ReportLists[4], (meComplete and not otherComplete)
		else
			return false, AYB.CompletedQueue, (meComplete and not otherComplete)
		end
	elseif onDemand then
		-- AYB.Print("Everyone's queues are running smoothly, Commander!")
		return true, AYB.ReportLists[4], nil
	end
end

function AYB.DisplayCompletedSingleShipment(toon, fallthrough)
	if next(AYB.Constants.BlockNotificationsTable) and not fallthrough then
		tinsert(AYB.Constants.SaveForLaterTable, {"toast", "shipment", toon})
		return
	end	
	local name = toon:match("([^-]+)-.+")
	GarrisonBuildingAlertFrame.Name:SetFormattedText("Idle building! (%s)", name);
	AlertFrame_AnimateIn(GarrisonBuildingAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_BuildingComplete");
end

function AYB.SearchAllForResourceLimit(onDemand, source)
	local limit = AllYourBaseVars.Settings.resourceWatchLimit
	for k, v in pairs(AllYourBaseVars.Data) do
		-- loop through people, check for anyone who's over, and then broadcast them if they need to
		if v.showMyResources and v.hasGarrison then
			if not onDemand then
				if time() >= v.cacheTimer and v.doBroadcastCache then
					tinsert(AYB.CompletedQueue, {k})
					if onDemand then
						tinsert(AYB.ReportLists[5], {k})
					end
					v.doBroadcastCache = false
				end
			else -- onDemand
				if time() >= v.cacheTimer then
					tinsert(AYB.CompletedQueue, {k})
					if onDemand then
						tinsert(AYB.ReportLists[5], {k})
					end
				end
			end
		end
	end
	return onDemand, AYB.CompletedQueue, false
end

function AYB.DisplayResourceLimitReached(toon, limit, fallthrough)
	if next(AYB.Constants.BlockNotificationsTable) and not fallthrough then
		tinsert(AYB.Constants.SaveForLaterTable, {"toast", "resources", toon})
		return
	end
	GarrisonBuildingAlertFrame.Name:SetFormattedText("%s: %d Resources!", toon, limit)
	AlertFrame_AnimateIn(GarrisonBuildingAlertFrame);
	AlertFrame_FixAnchors();
	PlaySound("UI_Garrison_Toast_BuildingComplete");
end

function AYB.CalculateResourceLimitTimers(character)
	if character then
		AllYourBaseVars.Data[character].cacheTimer = AllYourBaseVars.Data[character].lastRetrievedCache + (AllYourBaseVars.Settings.resourceWatchLimit / 6 * 3600)
		AllYourBaseVars.Data[character].doBroadcastCache = true
		-- math explanation: resources accumulate 1 every 10 minutes, or 6 per hour. Divide by 6 to get the hours before the limit is up, then multiply by 3600 for seconds
	else
		for k, v in pairs(AllYourBaseVars.Data) do
			if v.hasGarrison then
				AYB.CalculateResourceLimitTimers(k)
			end
		end
	end
	AllYourBaseReportPageTextLabel5:SetFormattedText("Garrison Resources \226\137\165 %d\n(use Settings to change limit)", AllYourBaseVars.Settings.resourceWatchLimit)
end

function AYB.SoundNotification(which, faction)
	local whichSound = AYB.NotificationSoundFiles[which][faction]
	PlaySoundFile(whichSound)	
end


function AYB.DisplayAllReports(source)
	AYB.CleanUpUnusedEntries("Missions")
	AYB.CleanUpUnusedEntries("Buildings")
	AYB.CleanUpUnusedEntries("Shipments")
	for k, v in ipairs(AYB.ReportLists) do
		AYB.ReportLists[k] = {}
	end
	if AllYourBaseVars.Settings.includeMissionsInStatus then		
		AYB.SearchAllForCompleteMissions(true, source)
		if next(AYB.ReportLists[1]) then -- if there are any characters who are reporting out on completed missions
			AYB.CreateReportPageItemList(1, AYB.ReportLists[1])
		else
			AYB.CreateReportPageItemList(1, nil, true)
		end
	end
	if AllYourBaseVars.Settings.includeIdleMissionsInStatus then
		AYB.SearchAllForIdleMissions(true, source)
		if next(AYB.ReportLists[2]) then
			AYB.CreateReportPageItemList(2, AYB.ReportLists[2])
		else
			AYB.CreateReportPageItemList(2, nil, true)
		end
	end
	if AllYourBaseVars.Settings.includeBuildingsInStatus then		
		AYB.SearchAllForCompleteBuildings(true, source)
		if next(AYB.ReportLists[3]) then -- if there are any characters who are reporting out on completed missions
			AYB.CreateReportPageItemList(3, AYB.ReportLists[3])
		else
			AYB.CreateReportPageItemList(3, nil, true)
		end
	end
	if AllYourBaseVars.Settings.includeShipmentsInStatus then		
		AYB.SearchAllForCompleteShipments(true, source)
		if next(AYB.ReportLists[4]) then -- if there are any characters who are reporting out on completed missions
			AYB.CreateReportPageItemList(4, AYB.ReportLists[4])
		else
			AYB.CreateReportPageItemList(4, nil, true)
		end
	end
	if AllYourBaseVars.Settings.includeResourcesInStatus then
		AYB.SearchAllForResourceLimit(true, source)
		if next(AYB.ReportLists[5]) then
			AYB.CreateReportPageItemList(5, AYB.ReportLists[5])
		else
			AYB.CreateReportPageItemList(5, nil, true)
		end
	end
	local toons, randomToon, speakerRace, intro = {}
	for k, v in pairs(AllYourBaseVars.Data) do
		if k ~= me then
			tinsert(toons, k)
		end
	end
	AllYourBaseReportPageReportText:SetWidth(500)
	AllYourBaseReportPageReportText:Show()
	if #toons == 0 then
		AllYourBaseReportPageReportText:SetText("I'm the only one with a Garrison so far, Commander! Check your Garrison report, and make sure to log into your other characters!")
	else
		randomToon = toons[random(#toons)]
		speakerRace = AllYourBaseVars.Data[randomToon].Race
		intro = AYB.StatusIntros[speakerRace][random(#AYB.StatusIntros[speakerRace])]
		AllYourBaseReportPageReportHeaderText:SetText("All Your Base: Status Report from "..randomToon:match("([^-]+)"))
		AllYourBaseReportPageReportText:SetFormattedText("%s reaches into a nearby mailbox and retrieves a neatly penned scroll. It reads:\n\n\"%s\"", shortMe, intro)
	end
	--[[
	for i, v in ipairs({"Missions", "Buildings", "Shipments"}) do
		local toon, objective, remaining = AYB.NextToComplete(v)
		if objective then
			_G["AllYourBaseReportPageNextTime"..i]:SetText(AYB.SecsToText(remaining))
			_G["AllYourBaseReportPageNextName"..i]:SetText("("..toon:match("([^-]+)")..")")
		else
			_G["AllYourBaseReportPageNextTime"..i]:SetText("None in progress!")
			_G["AllYourBaseReportPageNextName"..i]:SetText("")
		end
	end
	_G["AllYourBaseReportPageResourcesText"]:SetText(format("|cFFFFFF19Garrison Cache:|r %s", AYB.NextToonResourceCap()))
	--]]
	AYB.FadeFrame(AllYourBaseReportPage, 1)
end

function AYB.CharHasOpenMissions(toon)
	wipe(AYB.ReportLists[1])
	if not toon:find("-") and AllYourBaseVars.Settings.debugMode then
		AYB.Print("Mission check toon did not have a dash.")
		return
	end
	local check
	for k, v in ipairs(select(2, AYB.SearchAllForCompleteMissions(true, "from tooltip"))) do
		if v[1] == toon then
			check = true
		end
	end
	return check and 1 or 0
end

function AYB.CharHasOpenBuildings(toon)
	wipe(AYB.ReportLists[3])
	if not toon:find("-") and AllYourBaseVars.Settings.debugMode then
		AYB.Print("Building check toon did not have a dash.")
		return
	end
	local check
	for k, v in ipairs(select(2, AYB.SearchAllForCompleteBuildings(true, "from tooltip"))) do
		if v[1] == toon then
			check = true
		end
	end
	return check and 1 or 0
end

function AYB.CharHasOpenShipments(toon)
	wipe(AYB.ReportLists[4])
	if not toon:find("-") and AllYourBaseVars.Settings.debugMode then
		AYB.Print("Shipment check toon did not have a dash.")
		return
	end
	local check
	for k, v in ipairs(select(2, AYB.SearchAllForCompleteShipments(true, "from toolip"))) do
		if v[1] == toon then
			check = true
		end
	end
	return check and 1 or 0
end

function AYB.CharHasOpenIdleMissions(toon)
	wipe(AYB.ReportLists[2])
	if not toon:find("-") and AllYourBaseVars.Settings.debugMode then
		AYB.Print("Idle missions check toon did not have a dash.")
		return
	end
	local idlers = AYB.SearchAllForIdleMissions(true, "from tooltip")
	local check
	if idlers then
		for k, v in ipairs(idlers) do
			if v[1] == toon then
				check = true
				break
			end
		end
	end
	return check and 1 or 0
end

function AYB.CharHasOpenResources(toon)
	wipe(AYB.ReportLists[5])
	if not toon:find("-") and AllYourBaseVars.Settings.debugMode then
		AYB.Print("Garrison cache check toon did not have a dash.")
		return
	end
	local check
	for k, v in ipairs(select(2, AYB.SearchAllForResourceLimit(true, "from tooltip"))) do
		if v[1] == toon then
			check = true
		end
	end
	return check and 1 or 0
end

function AYB.CharHasOpenItem(toon)
	if not toon or not AllYourBaseVars.Data[toon] then
		return
	end
	local checkWhich = {
		AllYourBaseVars.Data[toon].showMyMissions,
		AllYourBaseVars.Data[toon].showMyIdleMissions,
		AllYourBaseVars.Data[toon].showMyBuildings,
		AllYourBaseVars.Data[toon].showMyShipments,
		AllYourBaseVars.Data[toon].showMyResources
	}
	local doWhich = {
		AllYourBase.CharHasOpenMissions,
		AllYourBase.CharHasOpenIdleMissions,
		AllYourBase.CharHasOpenBuildings,
		AllYourBase.CharHasOpenShipments,
		AllYourBase.CharHasOpenResources,
	}
	local actions = {
		"Collect Mission rewards!",
		"Start some new Missions!",
		"Finalize buildings!",
		"Build up Work Order Queues!",
		"Collect Garrison Resources!"
	}
	local tooltip = {}
	for i = 1, 5 do
		wipe(AYB.CompletedQueue)
		if checkWhich[i] then
			if doWhich[i](toon) == 1 then
				tinsert(tooltip, actions[i])
			end
		end
	end
	if AllYourBaseVars.Data[toon].hasMine then
		local ships = AllYourBaseVars.Data[toon].Shipments
		if (ships["Frostwall Mines"] and not ships["Frostwall Mines"].blacklist) or (ships["Lunarfall Excavation"] and not ships["Lunarfall Excavation"].blacklist) then
			if AllYourBaseVars.Data[toon].miningLeft > 0 then
				local line = format("Mine for ore: %s/%s left", AllYourBaseVars.Data[toon].miningLeft, AllYourBaseVars.Data[toon].maxMining)
				tinsert(tooltip, line)
			end
		end
	end
	if AllYourBaseVars.Data[toon].hasGarden then
		if (AllYourBaseVars.Data[toon].hasGarden and not AllYourBaseVars.Data[toon].Shipments["Herb Garden"].blacklist) then
			if AllYourBaseVars.Data[toon].herbingLeft > 0 then
				local line = format("Gather herbs: %s/%s left", AllYourBaseVars.Data[toon].herbingLeft, AllYourBaseVars.Data[toon].maxHerbing)
				tinsert(tooltip, line)
			end
		end
	end
	return tooltip
end

function AYB.CreateReportPageItemList(listNumber, dataTable, shouldClear, startIndex, endIndex)
	local labels = {"Missions", "IdleMissions", "Buildings", "WorkOrders", "GarrisonCache"}
	local label = labels[listNumber]
	local button = _G["AllYourBaseListButton"..listNumber]
	local i = 0
	if not startIndex then
		startIndex = 1
	end
	if not endIndex and dataTable then
		endIndex = (#dataTable > 7 and (startIndex + 6) or #dataTable)
	elseif not endIndex then
		endIndex = 1
	end
	if not AllYourBase.Indices[listNumber] then
		AllYourBase.Indices[listNumber] = {}
	end
	AllYourBase.Indices[listNumber].startIndex = startIndex
	AllYourBase.Indices[listNumber].endIndex = endIndex
	if startIndex == 1 then
		button.uparrow:Hide()
	else
		button.uparrow:Show()
	end
	if dataTable and (#dataTable <= 7 or endIndex == #dataTable) then
		button.downarrow:Hide()
	elseif dataTable then
		button.downarrow:Show()
	end
	if shouldClear then
		button.uparrow:Hide()
		button.downarrow:Hide()
	end
	if shouldClear then
		if not _G["AllYourBase"..label.."Item1Text"] then
			local b = CreateFrame("Button", "AllYourBase"..label.."Item1", AllYourBaseReportPage, "AllYourBaseReportItem")
			b:Show()
		end		
		_G["AllYourBase"..label.."Item1Text"]:SetText("Nothing to report, Commander!")
		_G["AllYourBase"..label.."Item1Text"]:SetTextColor(1,1,1,1)
		j = 2
		while _G["AllYourBase"..label.."Item"..j] do
			_G["AllYourBase"..label.."Item"..j]:Hide()
			_G["AllYourBase"..label.."Item"..j.."Text"]:SetText("")
			j = j + 1
		end
		return
	end
	local itemNumber = 0
	for i = startIndex, endIndex do
		if dataTable and dataTable[i] then
			itemNumber = itemNumber + 1
			local class = AllYourBaseVars.Data[dataTable[i][1]].class
			local item = _G["AllYourBase"..label.."Item"..itemNumber]
			local text = item.text
			item.detail = {}
			for j = 2, #dataTable[i] do
				tinsert(item.detail, dataTable[i][j])
			end
			item.characterName = dataTable[i][1]
			item.label = label
			text:SetTextColor(RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b, 1)
			if listNumber == 2 then
				text:SetFormattedText("%s", dataTable[i][1])
			elseif listNumber == 5 then
				local resources = (time() - AllYourBaseVars.Data[dataTable[i][1] ].lastRetrievedCache) / 60 / 60 * 6
				item.detail = resources >= 500 and 500 or math.floor(resources)
				text:SetFormattedText("%s (%s)", dataTable[i][1], (item.detail == 500 and "FULL!") or item.detail)
				if item.detail == 500 then
					text:SetTextColor(1, 0, 0, 1)
				end
			else
				text:SetFormattedText("%s (%s)", dataTable[i][1], #dataTable[i] - 1)
			end
			item:Show()
		end
	end
	if endIndex < 7 then
		for i = endIndex + 1, 7 do
			_G["AllYourBase"..label.."Item"..i]:Hide()
			_G["AllYourBase"..label.."Item"..i.."Text"]:SetText("")
		end
	end
	--[[
	for k, v in ipairs(dataTable) do
		i = i + 1
		local class = AllYourBaseVars.Data[v[1] ].class
		local item = _G["AllYourBase"..label.."Item"..i] or CreateFrame("Button", "AllYourBase"..label.."Item"..i, AllYourBaseReportPage, "AllYourBaseReportItem")
		item.detail = {}
		for j = 2, #v do
			tinsert(item.detail, v[j])
		end
		item.characterName = v[1]
		item.label = label
		if i > 1 then
			item:SetPoint("TOPLEFT", _G["AllYourBase"..label.."Item"..(i-1)], "BOTTOMLEFT", 0, 0)
		end
		local text = _G[item:GetName().."Text"]
		text:SetTextColor(RAID_CLASS_COLORS[class].r, RAID_CLASS_COLORS[class].g, RAID_CLASS_COLORS[class].b, 1)
		if i == 1 then
			text:SetText("Nothing to report, Commander!")
		end
		if label == "Idle Missions" then
			text:SetFormattedText("%s %s", RANGE_INDICATOR, v[1])
		elseif label == "Garrison Cache" then
			local resources = (time() - AllYourBaseVars.Data[v[1] ].lastRetrievedCache) / 60 / 60 * 6
			item.detail = resources >= 500 and 500 or math.floor(resources)
			text:SetFormattedText("%s %s (%s)", RANGE_INDICATOR, v[1], (item.detail == 500 and "FULL!") or item.detail)
			if item.detail == 500 then
				text:SetTextColor(1, 0, 0, 1)
			end
		else
			text:SetFormattedText("%s %s (%s)", RANGE_INDICATOR, v[1], #v - 1)
		end
		if not label:find("Work Orders") then
			item:SetScript("OnClick", nil)
		end
		item:Show()
	end
	i = i + 1
	while _G["AllYourBase"..label.."Item"..i] do
		_G["AllYourBase"..label.."Item"..i]:Hide()
		_G["AllYourBase"..label.."Item"..i.."Text"]:SetText("")
		i = i + 1
	end
	--]]
end

function AYB.Blacklist(building, character)
	if not building then
		AYB.Print("To blacklist a building's work orders, use \"/ayb blacklist <EXACT NAME OF BUILDING>.\" To review the contents of your blacklist, type /ayb blacklist show.")
		return
	else
		building = AYB.ProperCase(building)
	end
	if not character then
		character = me
	end
	if not AllYourBaseVars.Data[character].Shipments[building] then
		AYB.Print(format("I don't know anything about %s's %s. Maybe you haven't done any work orders there yet?", character, building))
		return
	else
		AYB.Print(format(AllYourBaseVars.Data[character].Shipments[building].blacklist and "%s's %s has been removed from the blacklist, and you will now get notifications when its queue is up." or "Blacklisting %s's %s! Its work orders will no longer be called to your attention.", character, building))
		AllYourBaseVars.Data[character].Shipments[building].blacklist = not AllYourBaseVars.Data[character].Shipments[building].blacklist
	end
end

function AYB.RemoveCharacter(character)
	if AllYourBaseVars.Data[character] then
		AllYourBaseVars.Data[character] = nil
		AYB.Print(format("Removed %s's records from the Status Report. Make sure to disable All Your Base for %s if you don't want their information coming back in later.", character, character))
	else
		AYB.Print(format("Couldn't locate information for %s. Try typing /ayb erase CHARACTER-SERVER.", character))
	end
end

function AYB.FakeWhisper(character, msg, fallthrough)
	if next(AYB.Constants.BlockNotificationsTable) and not fallthrough then
		tinsert(AYB.Constants.SaveForLaterTable, {"message", msg, character})
		return
	end	
	local toon = (character:find("-")) and character:match("([^-]+)") or character
	AYB.Print(format('%s snaps to a crisp salute. "%s"', toon, msg))
	PlaySound("TellMessage")
end

function AYB.DoSavedNotifications(isLoop)
	if not isLoop then	
		-- we are done with combat or whatever and need to get the first "3" saved items
		-- call the function with "isLoop" is true and then when that's true... do stuff
		AYB.DoSavedNotifications(true)
	else
		if AYB.Constants.CurrentSavedNotifications == AYB.Constants.MaxSavedNotifications or not next(AYB.Constants.SaveForLaterTable) then
			if AYB.SaveForLaterTable then
				wipe(AYB.SaveForLaterTable)
			end
			AYB.Constants.CurrentSavedNotifications = 0
			return
		end
		AYB.Constants.CurrentSavedNotifications = AYB.Constants.CurrentSavedNotifications + 1
		C_Timer.After(5, function()
			local notificationType, notificationSubject, character = AYB.Constants.SaveForLaterTable[1][1], AYB.Constants.SaveForLaterTable[1][2], AYB.Constants.SaveForLaterTable[1][3]
			tremove(AYB.Constants.SaveForLaterTable, 1)
			if notificationType:find("text") then
				local msg = (notificationSubject == "mission" and "Mission completed!") or (notificationSubject == "building" and "I've completed a building!") or (notificationSubject == "shipment" and "One of my work orders needs attention!") or "My Garrison Cache is past its limit!"
				AYB.FakeWhisper(character, msg, true)
			end
			if notificationType:find("toast") then
				if notificationSubject == "resources" then
					AYB.DisplayResourceLimitReached(character, AllYourBaseVars.Settings.resourceWatchLimit, true)
				elseif notificationSubject == "shipment" then
					AYB.DisplayCompletedSingleShipment(character, true)
				elseif notificationSubject == "building" then
					AYB.DisplayCompletedSingleBuilding(character, true)
				elseif notificationSubject == "mission" then
					AYB.DisplayCompletedSingleMission(character, true)
				end
			end
			if notificationType:find("sound") then
			
			end
			AYB.DoSavedNotifications(true)
		end)					
		-- ok we're in a loop.
		-- increment the loop counter
		-- do a C_Timer to do the first thing in the table and simultaneously remove the first thing in the table. do then call the DoSavedNotifications thing again, with isLoop is true
		-- check if this is the last one we should do. if it is, wipe the table and return

	end
end

function AYB.CompareLoginTimes(toon, when)
	if not AllYourBaseVars.Data[toon].lastLogin then
		AllYourBaseVars.Data[toon].lastLogin = {
			["time"] = time(),
			["resetTime"] = GetQuestResetTime(),
		}
		AYB.ResetDailyInformation(toon, when)
		return
	end
	local oldTime, oldResetTime = AllYourBaseVars.Data[toon].lastLogin.time, AllYourBaseVars.Data[toon].lastLogin.resetTime
	AllYourBaseVars.Data[toon].lastLogin = {
			["time"] = time(),
			["resetTime"] = GetQuestResetTime(),
	}
	if (AllYourBaseVars.Data[toon].lastLogin.time - oldTime > 86400) or (oldResetTime < GetQuestResetTime()) then -- either more than a day since last login, or less than a day but quest reset timer has gone UP
		AYB.ResetDailyInformation(toon, when)
	end
end

function AYB.ResetDailyInformation(toon, when)
	local mines = {61, 62, 63}
	local gardens = {29, 136, 137}
	local ores = {8, 13, 18}
	local herbs = {6, 10, 15}
	local ore, herb
	local buildings, myMine, myGarden = C_Garrison.GetBuildings()
	for i = 1, #buildings do
		local buildingID = buildings[i].buildingID
		for k, v in ipairs(mines) do
			if v == buildingID then
				myMine = k
			end
		end
		for k, v in ipairs(gardens) do
			if v == buildingID then
				myGarden = k
			end
		end
	end
	if myMine then
		ore = ores[myMine]
		AllYourBaseVars.Data[toon].miningLeft = ore
		AllYourBaseVars.Data[toon].maxMining = ore
		AllYourBaseVars.Data[toon].hasMine = true
	end
	if myGarden then
		herb = herbs[myGarden]
		AllYourBaseVars.Data[toon].herbingLeft = herb
		AllYourBaseVars.Data[toon].maxHerbing = herb
		AllYourBaseVars.Data[toon].hasGarden = true
	end
	AYB.Print("Reseting your Mine and Garden node counts!")
end

--[[
function AYB.IncrementNode(which, toon, count)
	local left = (which == "ore" and "miningLeft" or "herbingLeft")
	local maxi = (which == "ore" and "maxMining" or "herbingLeft")
	for i = 1, count do
		AllYourBaseVars.Data[toon][left] = AllYourBaseVars.Data[toon][left] + 1
		AllYourBaseVars.Data[toon][maxi] = AllYourBaseVars.Data[toon][maxi] + 1
	end
	AYB.Debug(format("Added %d %s for %s", count, which, toon))
end
--]]

function AYB.DecrementNode(which, toon)
	if which == "herb" then
		AllYourBaseVars.Data[toon].herbingLeft = AllYourBaseVars.Data[toon].herbingLeft - 1
		if AllYourBaseVars.Data[toon].herbingLeft == 0 then
			AYB.Debug("All herbs gathered.")
		end
	elseif which == "ore" then
		AllYourBaseVars.Data[toon].miningLeft = AllYourBaseVars.Data[toon].miningLeft - 1
		if AllYourBaseVars.Data[toon].miningLeft == 0 then
			AYB.Debug("All ore mined.")
		end
	else
		AYB.Debug(format("Could not decrement for %s - \"%s\" is unknown.", toon, which))
	end
end

function AYB.SlashHandler(cmd)
	if cmd:find("blacklist") then
		AYB.Blacklist(cmd:match("blacklist (.+)"))
	elseif cmd:find("erase") then
		AYB.RemoveCharacter(cmd:match("erase (.+)"))
	elseif cmd == "status" then
		AYB.DisplayAllReports("slash")
	else
		AYB.Print("Unknown option. Try \"/ayb status\" or \"/ayb blacklist <BUILDING>\" or \"/ayb erase <CHARACTER-SERVER>\"")
	end
end

SLASH_ALLYOURBASE1 = "/ayb"
SlashCmdList["ALLYOURBASE"] = function(msg)
	AYB.SlashHandler(msg)
	end
	
function AYB.ReportPage_OnLoad(self)
	local texts = {"Missions", "Idle Missions", "Buildings", "Work Orders", "Garrison Cache"}
	local icons = {"Interface\\Icons\\Ability_DualWield", "Interface\\Icons\\Spell_Nature_Sleep", "Interface\\Icons\\INV_Garrison_Blueprints2", "Interface\\ICONS\\Garrison_Building_Storehouse", "Interface\\icons\\inv_garrison_resource"}
	local points = { {65, -190} , {265, -190}, {465, -190}, {150, -420}, {380, -420} }
	for i = 1, 5 do
		local button = CreateFrame("Button", "AllYourBaseListButton"..i, self, "AllYourBaseReportButtonTemplate")
		_G[button:GetName().."Texture"]:SetTexture(icons[i])
		button:SetHeight(30)
		button:SetWidth(30)
		button:SetPoint("TOPLEFT", points[i][1], points[i][2])
		button:SetHighlightTexture(nil)
		button:SetPushedTexture(nil)
		local t = self:CreateFontString("AllYourBaseReportPageTextLabel"..i, "BORDER", "GameFontNormal")
		t:SetPoint("TOPLEFT", points[i][1] + 39, points[i][2] - ((i==4 and 1) or (i==5 and 1) or 7))
		if i == 5 then
			t:SetFormattedText("Garrison Resources \226\137\165 %d\n(use Settings to change limit)", AllYourBaseVars.Settings.resourceWatchLimit)
		elseif i ==4 then
			t:SetText("Idle Buildings\n(click name to blacklist)")
		else
			t:SetText(texts[i])
		end
		local firstItem = CreateFrame("Button", "AllYourBase"..texts[i]:gsub(" ","").."Item1", self, "AllYourBaseReportItem")
		firstItem:SetPoint("TOPLEFT", points[i][1] + 20, points[i][2] - 35)
		firstItem.text = _G[firstItem:GetName().."Text"]
		firstItem.text:SetJustifyH("LEFT")
		firstItem:Show()
		firstItem:EnableMouseWheel(true)
		firstItem.listID = i
		for j = 2, 7 do
			local button = CreateFrame("Button", "AllYourBase"..texts[i]:gsub(" ","").."Item"..j, self, "AllYourBaseReportItem")
			button:SetPoint("TOPLEFT", _G["AllYourBase"..texts[i]:gsub(" ","").."Item"..(j-1)], "BOTTOMLEFT", 0, 0)
			button.text = _G[button:GetName().."Text"]
			button.text:SetJustifyH("LEFT")
			button:Show()
			button:EnableMouseWheel(true)
			button.listID = i
		end
		button.uparrow = CreateFrame("Button", "AllYourBase"..texts[1].."UpArrow", button)
		button.uparrow:SetHeight(15)
		button.uparrow:SetWidth(15)
		button.uparrow:SetPoint("TOPLEFT", 5, -37)
		button.uparrow:SetScript("OnClick", function() AllYourBase.ReportItem_OnMouseWheel(firstItem, 1) end)
		button.uparrow:Hide()
		local uptext = button.uparrow:CreateFontString(nil, "BORDER", "ChatFontSmall")
		uptext:SetPoint("CENTER")
		uptext:SetText("\226\134\145")
		button.downarrow = CreateFrame("Button", "AllYourBase"..texts[1].."DownArrow", button)
		button.downarrow:SetHeight(15)
		button.downarrow:SetWidth(15)
		button.downarrow:SetPoint("TOPLEFT", 5, -156)
		button.downarrow:SetScript("OnClick", function() AllYourBase.ReportItem_OnMouseWheel(firstItem, -1) end)
		button.downarrow:Hide()
		local downtext = button.downarrow:CreateFontString(nil, "BORDER", "ChatFontSmall")
		downtext:SetPoint("CENTER")
		downtext:SetText("\226\134\147")
	end
	AYB.Tooltip = AllYourBase.Tooltip or CreateFrame("GameTooltip", "AllYourBaseTooltip", UIParent, "GameTooltipTemplate")
end

function AllYourBase.ReportItem_OnMouseWheel(self, delta)
	local listNumber = self.listID
	local oldStart, oldEnd = AllYourBase.Indices[listNumber].startIndex, AllYourBase.Indices[listNumber].endIndex
	local newStart, newEnd = oldStart - delta, oldStart - delta + 6
	if newStart >= 1 and newEnd <= #AYB.ReportLists[listNumber] then
		AYB.CreateReportPageItemList(listNumber, AYB.ReportLists[listNumber], nil, newStart, newEnd)
	end
end

function AYB.FadeFrame(frame, a)
	if not frame:IsShown() then
		frame:Show()
	end
	frame.Timer = (a == 1 and 0 ) or 0.25
	frame.keepFading = true
	frame:SetScript("OnUpdate", function(self, elapsed) self.Timer = self.Timer + (a * elapsed)
		if self.keepFading then
			self:SetAlpha(self.Timer * 4)
		end
		if (a == 1 and self.Timer >= 0.25) then 
			if self:GetName() == "AllYourBaseReportPage" and self.keepFading then
				-- AYB.ReportModelTimer:Show()
			end
			self.keepFading = false
		elseif (a == -1 and self.Timer <= 0) then
			self.keepFading = false
			self:Hide()
		end
	end)
end

function AYB.InitializeAccountVariablesAndSettings()
	
	local defaults =  {
		["scanForShipments"] = true,
		["scanForBuildings"] = true,
		["includeMissionsInStatus"] = true,
		["scanForMissions"] = true,
		["includeIdleMissionsInStatus"] = true,
		["includeBuildingsInStatus"] = true,
		["includeShipmentsInStatus"] = true,
		["includeResourcesInStatus"] = true,
		["displayReportAtLogin"] = false,
		["doNotNotifyDuringBattle"] = false,
		["doNotNotifyDuringPVP"] = false,
		["doNotNotifyDuringRaid"] = false,
		["notifyOnQueueUpdate"] = true,
		["resourceWatchLimit"] = 450,
		["scanForResources"] = true,
		["debugMode"] = false,
		["displayToastNotifications"] = true,
		["displayTextNotifications"] = true,
		["displaySoundNotifications"] = false,
	}
		
	if not AllYourBaseVars then
		AllYourBaseVars = {
			["CurrentVersion"] = AYB.Constants.CurrentVersion,
			["Data"] = {},
			["Settings"] = {}
		}
		for k, v in pairs(defaults) do
			AllYourBaseVars.Settings[k] = v
		end
		return
	end
	AllYourBaseVars.CurrentVersion = AYB.Constants.CurrentVersion
	AYB.Print(format("Updated Saved Variables to version %s!", AYB.Constants.CurrentVersion))
	for k, v in pairs(defaults) do
		if AllYourBaseVars.Settings[k] == nil then
			AYB.Debug("There is no saved setting for "..k.." so I am setting it to "..tostring(v))
			AllYourBaseVars.Settings[k] = v
		end
	end
	for k, v in pairs(AllYourBaseVars.Settings) do
		if defaults[k] == nil then
			AYB.Debug("There is no default setting for "..k.." so I am removing it from SV.")
			AllYourBaseVars.Settings[k] = nil
		end
	end
end

function AYB.InitializeCharacterVariablesAndSettings(toon)
	AllYourBaseVars.Data[toon] = {
		["Buildings"] = {},
		["Shipments"] = {},
		["Missions"] = {},
		["Followers"] = {},
		["Race"] = race,
		["RaceID"] = AYB.RaceIDs[race],
		["cacheTimer"] = 1999999999,
		["lastRetrievedCache"] = 1999999999,
		["doBroadcastCache"] = false,
		["showMyMissions"] = true,
		["showMyIdleMissions"] = true,
		["showMyBuildings"] = true,
		["showMyShipments"] = true,
		["showMyResources"] = true,
		["hasGarrison"] = false,
		["class"] = select(2, UnitClass("player"))
	}
end

function AYB.UpdateHasGarrisonStatus()
	if not AllYourBaseVars.Data[me].hasGarrison and (IsQuestFlaggedCompleted(34586) or IsQuestFlaggedCompleted(34378)) then
		AllYourBaseVars.Data[me].hasGarrison = true
	end
end

function AYB.BlacklistDropdown_Init(frame, level, menuList)
	local toon = AYB.BlacklistCharacter or me
	local info = UIDropDownMenu_CreateInfo()
	--[[
	for k, v in ipairs({
		"Alchemy Lab",
		"Barn",
		"War Mill / Dwarven Bunker",
		"Enchanter's Study",
		"Engineering Works",
		"Gem Boutique",
		"Gladiator's Sanctum",
		"Goblin Workshop / Gnomish Gearworks",
		"Lumber Mill",
		"Frostwall Tavern / Lunarfall Inn",
		"Spirit Lodge / Mage Tower",
		"Salvage Yard",
		"Scribe's Quarters",
		"Stables",
		"Storehouse",
		"Tailoring Emporium",
		"The Forge",
		"The Tannery",
		"Trading Post",
		"Herb Garden",
		"Frostwall Mines / Lunarfall Excavation"	
	}) do
	--]]
	for k, v in pairs(AllYourBaseVars.Data[toon].Shipments) do
		-- info.text = v
		-- info.arg1 = v
		info.text = k
		info.arg1 = k
		--[[
		if k:find(" / ") then
			local b1, b2 = k:match("(.+) / (.+)")
			if not AllYourBaseVars.Data[toon].Shipments[b1] and not AllYourBaseVars.Data[toon].Shipments[b2] then
				info.disabled = true
			elseif (AllYourBaseVars.Data[toon].Shipments[b1] and AllYourBaseVars.Data[toon].Shipments[b1].blacklist) or (AllYourBaseVars.Data[toon].Shipments[b2] and AllYourBaseVars.Data[toon].Shipments[b2].blacklist) then
				info.colorCode = "|cFFFF0000"
			end
		elseif not AllYourBaseVars.Data[toon].Shipments[v] then
			info.disabled = true
		elseif AllYourBaseVars.Data[toon].Shipments[v].blacklist then
			info.colorCode = "|cFFFF0000"
		end
		--]]
		if v.blacklist then
			info.colorCode = "|cFFFF0000"
		end
		info.func = AYB.SetCharacterBuildingBlacklist
		info.isNotRadio = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info)
		wipe(info)
	end
end

function AYB.OptionsDropdown_Init(frame, level, menuList)
	local info = UIDropDownMenu_CreateInfo()

	if level == 1 then
		info.text = "Report Options"
		info.justifyH = "CENTER"
		info.isTitle = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Status report on log-in"
		info.checked = AllYourBaseVars.Settings.displayReportAtLogin
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.displayReportAtLogin = not AllYourBaseVars.Settings.displayReportAtLogin
		end
		info.isNotRadio = 1
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Show Missions"
		info.checked = AllYourBaseVars.Settings.includeMissionsInStatus
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.includeMissionsInStatus = not AllYourBaseVars.Settings.includeMissionsInStatus
			if not AllYourBaseVars.Settings.includeMissionsInStatus then
				AYB.CreateReportPageItemList(1, nil, true)
			end
			AYB.RefreshStatusReport()
		end
		info.isNotRadio = 1
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Show Idle Missions"
		info.checked = AllYourBaseVars.Settings.includeIdleMissionsInStatus
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.includeIdleMissionsInStatus = not AllYourBaseVars.Settings.includeIdleMissionsInStatus
			if not AllYourBaseVars.Settings.includeIdleMissionsInStatus then
				AYB.CreateReportPageItemList(2, nil, true)
			end
			AYB.RefreshStatusReport()
		end
		info.isNotRadio = 1
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Show Buildings"
		info.checked = AllYourBaseVars.Settings.includeBuildingsInStatus
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.includeBuildingsInStatus = not AllYourBaseVars.Settings.includeBuildingsInStatus
			if not AllYourBaseVars.Settings.includeBuildingsInStatus then
				AYB.CreateReportPageItemList(3, nil, true)
			end
			AYB.RefreshStatusReport()
		end
		info.isNotRadio = 1
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Show Idle Buildings"
		info.checked = AllYourBaseVars.Settings.includeShipmentsInStatus
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.includeShipmentsInStatus = not AllYourBaseVars.Settings.includeShipmentsInStatus
			if not AllYourBaseVars.Settings.includeShipmentsInStatus then
				AYB.CreateReportPageItemList(4, nil, true)
			end
			AYB.RefreshStatusReport()
		end
		info.isNotRadio = 1
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Show Cache Resources"
		info.checked = AllYourBaseVars.Settings.includeResourcesInStatus
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.includeResourcesInStatus = not AllYourBaseVars.Settings.includeResourcesInStatus
			if not AllYourBaseVars.Settings.includeResourcesInStatus then
				AYB.CreateReportPageItemList(5, nil, true)
			end
			AYB.RefreshStatusReport()
		end
		info.isNotRadio = 1
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = " "
		info.isTitle = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Notification Options"
		info.justifyH = "CENTER"
		info.isTitle = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Notify of completed Missions"
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.scanForMissions
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.scanForMissions = not AllYourBaseVars.Settings.scanForMissions
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Notify of completed Buildings"
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.scanForBuildings
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.scanForBuildings = not AllYourBaseVars.Settings.scanForBuildings
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Notify of Idle Buildings"
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.scanForShipments
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.scanForShipments = not AllYourBaseVars.Settings.scanForShipments
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Notify when Cache hits limit"
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.scanForResources
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.scanForResources = not AllYourBaseVars.Settings.scanForResources
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)

		info.text = "Click to change Cache limit"
		info.justifyH = "CENTER"
		info.notCheckable = 1
		info.func = function(arg1, arg2)
			AllYourBaseResourceLimitSliderWindow:Show()
		end
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Use text notification"
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.displayTextNotifications
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.displayTextNotifications = not AllYourBaseVars.Settings.displayTextNotifications
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Use pop-up notification"
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.displayToastNotifications
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.displayToastNotifications = not AllYourBaseVars.Settings.displayToastNotifications
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
	
		info.text = "Use sound notification"
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.displaySoundNotifications
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.displaySoundNotifications = not AllYourBaseVars.Settings.displaySoundNotifications
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)		

		info.text = "No notifications in battle"
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.doNotNotifyDuringBattle
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.doNotNotifyDuringBattle = not AllYourBaseVars.Settings.doNotNotifyDuringBattle
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		--[[
		info.text = "No notifications in raid (NYI)"
		info.disabled = 1
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.doNotNotifyDuringRaid
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.doNotNotifyDuringRaid = not AllYourBaseVars.Settings.doNotNotifyDuringRaid
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "No notifications in BG/Arena (NYI)"
		info.disabled = 1
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.doNotNotifyDuringPVP
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.doNotNotifyDuringPVP = not AllYourBaseVars.Settings.doNotNotifyDuringPVP
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		--]]
		
		info.text = " "
		info.isTitle = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Work Order Options"
		info.justifyH = "CENTER"
		info.isTitle = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Chat message for new work order"
		info.isNotRadio = 1
		info.checked = AllYourBaseVars.Settings.notifyOnQueueUpdate
		info.func = function(arg1, arg2)
			AllYourBaseVars.Settings.notifyOnQueueUpdate = not AllYourBaseVars.Settings.notifyOnQueueUpdate
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Re-sync this character's work orders"
		info.justifyH = "CENTER"
		info.isNotRadio = 1
		info.notCheckable = 1
		info.func = function(arg1, arg2)
			local keepBlacklists = {}
			for k, v in pairs(AllYourBaseVars.Data[me].Shipments) do
				if v.blacklist then
					tinsert(keepBlacklists, k)
				end
			end
			AllYourBaseVars.Data[me].Shipments = {}
			AYB.AddAnyMissing()
			for k, v in ipairs(keepBlacklists) do
				AllYourBaseVars.Data[me].Shipments[v].blacklist = true
			end
			AYB.RefreshStatusReport()
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Blacklist all Gardens"
		info.justifyH = "CENTER"
		info.isNotRadio = 1
		info.notCheckable = 1
		info.func = function(arg1, arg2)
			for k, v in pairs(AllYourBaseVars.Data) do
				for l, w in pairs(v.Shipments) do
					if l == "Herb Garden" then
						w.blacklist = true
					end
				end
			end
			AYB.RefreshStatusReport()
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Blacklist all Mines"
		info.justifyH = "CENTER"
		info.isNotRadio = 1
		info.notCheckable = 1
		info.func = function(arg1, arg2)
			for k, v in pairs(AllYourBaseVars.Data) do
				for l, w in pairs(v.Shipments) do
					if l == "Lunarfall Excavation" or l == "Frostwall Mines" then
						w.blacklist = true
					end
				end
			end
			AYB.RefreshStatusReport()
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Clear all characters' blacklists"
		info.justifyH = "CENTER"
		info.isNotRadio = 1
		info.notCheckable = 1
		info.func = function(arg1, arg2)
			for k, v in pairs(AllYourBaseVars.Data) do
				for l, w in pairs(v.Shipments) do
					w.blacklist = false
				end
			end
			AYB.RefreshStatusReport()
		end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = " "
		info.isTitle = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Character-Specific Options"
		info.justifyH = "CENTER"
		info.isTitle = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		for k, v in pairs(AllYourBaseVars.Data) do
			info.text = k
			info.value = k
			info.hasArrow = true
			info.notCheckable = 1
			info.colorCode = "|c"..RAID_CLASS_COLORS[AllYourBaseVars.Data[k].class].colorStr
			UIDropDownMenu_AddButton(info, level)
			wipe(info)
		end
		
	elseif level == 2 then
		info.text = UIDROPDOWNMENU_MENU_VALUE
		info.isTitle = 1
		info.justifyH = "CENTER"
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		local options = {
			{"showMyMissions", "Track my Missions"},
			{"showMyIdleMissions", "Track my Idle Missions"},
			{"showMyBuildings", "Track my Buildings"},
			{"showMyShipments", "Track my Idle Buildings"},
			{"showMyResources", "Track my Garrison Cache"}
		}
		
		for k, v in ipairs(options) do
			info.text = v[2]
			info.isNotRadio = 1
			info.checked = AllYourBaseVars.Data[UIDROPDOWNMENU_MENU_VALUE][v[1]]
			info.func = function(arg1, arg2)
				AllYourBaseVars.Data[UIDROPDOWNMENU_MENU_VALUE][v[1]] = not AllYourBaseVars.Data[UIDROPDOWNMENU_MENU_VALUE][v[1]]
				AYB.RefreshStatusReport()
			end
			info.keepShownOnClick = 1
			UIDropDownMenu_AddButton(info, level)
			wipe(info)
		end
		
		info.text = " "
		info.isTitle = 1
		info.notCheckable = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Remove All Work Order Blacklists"
		info.notCheckable = 1
		info.justifyH = "CENTER"
		info.func = function() for k,v in pairs(AllYourBaseVars.Data[UIDROPDOWNMENU_MENU_VALUE].Shipments) do v.blacklist = false end AYB.RefreshStatusReport() end
		info.keepShownOnClick = 1
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
		info.text = "Remove Character Data"
		info.colorCode = "|cFFFF1111"
		if me == UIDROPDOWNMENU_MENU_VALUE then
			info.disabled = 1
			info.text = "Cannot Remove Current Character Data"
		end
		info.notCheckable = 1
		info.justifyH = "CENTER"
		info.func = function() AYB.RemoveCharacter(UIDROPDOWNMENU_MENU_VALUE) DropDownList1:Hide() AYB.RefreshStatusReport() end
		UIDropDownMenu_AddButton(info, level)
		wipe(info)
		
	end
end

function AYB.BlacklistBuildingDropdown_OnLoad(self)
	UIDropDownMenu_Initialize(self, AYB.BlacklistDropdown_Init)
end

function AYB.OptionsDropdown_OnLoad(self)
	UIDropDownMenu_Initialize(self, AYB.OptionsDropdown_Init, "MENU")
end

function AYB.ReportItem_OnEnter(self)
	AYB.Tooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	local shortName
	if self.characterName then
		shortName = self.characterName:match("([^-]+)")
	end
	if self.label == "Buildings" or self.label == "WorkOrders" then
		AYB.Tooltip:ClearLines()
		AYB.Tooltip:AddLine((self.label == "Buildings" and format("%s's Completed buildings:", shortName or self.characterName)) or format("%s's Idle Buildings:", shortName or self.characterName), 1, 1, 1)
		if type(self.detail) == "table" then
			for k, v in ipairs(self.detail) do
				AYB.Tooltip:AddLine(v)
			end
		else
			AYB.Tooltip:AddLine(self.detail)
		end
		AYB.Tooltip:Show()
	end
end

function AYB.ReportItem_OnLeave(self)
	AYB.Tooltip:ClearLines()
	AYB.Tooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	AYB.Tooltip:Hide()
end

function AYB.ReportItem_OnClick(self, button, down)
	AYB.BlacklistCharacter = self.characterName
	ToggleDropDownMenu(1, nil, AllYourBaseBlacklistBuildingDropdown, self:GetName(), 0, 0)
end

function AYB.ReportOptions_OnClick(self, button, down)
	AllYourBaseOptionsDropdown.xOffset = 0
	AllYourBaseOptionsDropdown.yOffset = 0
	AllYourBaseOptionsDropdown.point = "TOPLEFT"
	AllYourBaseOptionsDropdown.relativePoint = "TOPRIGHT"
	ToggleDropDownMenu(1, nil, AllYourBaseOptionsDropdown, AllYourBaseReportPageReport)
end

function AYB.StatusButton_OnEnter(self)
	AYB.Tooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	AYB.Tooltip:AddLine(format("Task List for %s:", shortMe), 1, 1, 1)
	if not next(AYB.CharHasOpenItem(me)) then
		AYB.Tooltip:AddLine("All tasks completed!")
	else
		for k, v in pairs(AYB.CharHasOpenItem(me)) do
			AYB.Tooltip:AddLine(v)
		end
	end
	AYB.Tooltip:Show()
end

function AYB.StatusButton_OnLeave(self)
	AYB.Tooltip:ClearLines()
	AYB.Tooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	AYB.Tooltip:Hide()
end

function AYB.SetCharacterBuildingBlacklist(self, building)
	local name = AYB.BlacklistCharacter
	AYB.Blacklist(building, name)
	AYB.RefreshStatusReport()
end

function AYB.RefreshStatusReport()
	if AllYourBaseReportPage:IsShown() then
		AllYourBaseReportPage.CloseButton:Click()
		AYB.DisplayAllReports("slash")
	end
end

AYB.Main:SetScript("OnEvent", AYB.Main.OnEvent)
AYB.Main:SetScript("OnUpdate", AYB.Main.OnUpdate)
AYB.ShipmentUpdater:SetScript("OnUpdate", AYB.ShipmentUpdater.OnUpdate)
AYB.WhichCrafter:SetScript("OnEvent", AYB.ParseCrafter)
AYB.DailyResetFrame:SetScript("OnUpdate", AYB.DailyResetFrame.OnUpdate)

-- Utility functions

function AYB.TextToSecs(timeLeft)
	if not timeLeft then
		return
	end
	local hr, mins, secs
	if string.find(timeLeft, "hr") then
		hr = string.match(timeLeft, "(%d+) hr")
	end
	if string.find(timeLeft, "min") then
		mins = string.match(timeLeft, "(%d+) min")
	end
	hr = hr or 0; mins = mins or 0
	return ((hr * 3600) + (mins * 60))
end

function AYB.SecsToText(timeLeft)
	local hr, mins, secs = math.floor(timeLeft / 3600), math.floor(timeLeft / 60) % 60, timeLeft % 60
	return format("%d hr, %d min, %d sec", hr, mins, secs)
end

function AYB.ProperCase(str)
	local w1, w2
	if str:find(" ") then
		w1, w2 = str:match("(%S+) (%S+)")
	end
	return w2 and (w1:sub(1,1):upper() .. w1:sub(2) .. " " .. w2:sub(1,1):upper() .. w2:sub(2)) or (str:sub(1,1):upper() .. str:sub(2))
end

function AYB.ReturnSingleKey(t)
	local e, key = 0
	for k, v in pairs(t) do
		e = e + 1
		key = k
	end
	return (e == 1 and key) or ("MORE THAN ONE KEY")
end

function AYB.Print(msg)
	print(format("|cFFFFFF19All Your Base:|r |cFF99CCFF%s", msg))
end

function AYB.Debug(msg)
	if AllYourBaseVars.Settings.debugMode then
		print(format("|cFFFFFF19All Your Base DEBUG:|r |cFF99CCFF%s", msg))
	end
end

function AYB.PrintAtPEW(t)
	if AllYourBaseVars.Settings.debugMode and next(t) then
		AYB.Print(unpack(t))
	end	
	wipe(t)
end

function AYB.HashLength(t)
	if not t then
		return 0
	end
	local i = 0
	for k, v in pairs(t) do
		i =  i + 1
	end
	return i
end